// Mark Kamichoff
// kamicm@rpi.edu
// Homework 1

#include <stdio.h>
#include <stdlib.h>
#include <GL/glut.h>

#define MAXOBJECTS 16383
#define INIT_W 640
#define INIT_H 480

void myinit(void);
void myReshape(GLsizei, GLsizei);
void key(unsigned char, int, int);

// globals
int win_width, win_height;

int global_spin = 1;

int the_shape = 1;
int the_rotate_axis = 0;
float the_rotate_speed = 0;
float the_color_r = 1.0;
float the_color_g = 1.0;
float the_color_b = 1.0;
int the_size = 1;
int num_objects = 0;
int the_origin = 1;

// 0  1   2         3            4         5       6       7            8             9            10
// x, y, shape, rotateaxis, rotatespeed, colorr, colorg, colorb, sizemultiplier, currentangle, theorigin(1/2)
float **drawn_objects;

// Main display function
void display(void)
{
	int i;

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();

	// Redraw everything in existance!
	for(i = 0; i < num_objects; i++)
	{
		glPushMatrix();

		// We move the origin
		if(drawn_objects[i][10] == 2)
		{
			glTranslatef(drawn_objects[i][0],
					drawn_objects[i][1], 0.0);
		}

		// If we have to rotate at all
		if(drawn_objects[i][4] != 0)
		{
			if(global_spin)
			{
				drawn_objects[i][9] += 0.1*drawn_objects[i][4];
	
				if(drawn_objects[i][9] > 360.0)
					drawn_objects[i][9] -= 360.0;
			}
			
			if(drawn_objects[i][3] == 0)
				glRotatef(drawn_objects[i][9], 1.0, 0.0, 0.0);
			else if(drawn_objects[i][3] == 1)
				glRotatef(drawn_objects[i][9], 0.0, 1.0, 0.0);
			else if(drawn_objects[i][3] == 2)
				glRotatef(drawn_objects[i][9], 0.0, 0.0, 1.0);
			else if(drawn_objects[i][3] == 3)
				glRotatef(drawn_objects[i][9], 1.0, 1.0, 0.0);
		}

		// Set the color
		glColor3f(drawn_objects[i][5],
				drawn_objects[i][6],
				drawn_objects[i][7]);

		// Square
		if(drawn_objects[i][2] == 1)
		{
			glBegin(GL_POLYGON);
				// This is if we want it to be its own rotate origin
				if(drawn_objects[i][10] == 2)
				{
					glVertex3f(0-(drawn_objects[i][8]*0.05),
							0+(drawn_objects[i][8]*0.05),0.0);
					glVertex3f(0+(drawn_objects[i][8]*0.05),
							0+(drawn_objects[i][8]*0.05),0.0);
	
					// Modify color for trippy effect
					glColor3f(drawn_objects[i][5]-0.6,
							drawn_objects[i][6]-0.6,
							drawn_objects[i][7]-0.6);
		
					glVertex3f(0+(drawn_objects[i][8]*0.05),
							0-(drawn_objects[i][8]*0.05),0.0);
					glVertex3f(0-(drawn_objects[i][8]*0.05),
							0-(drawn_objects[i][8]*0.05),0.0);

				}
				else
				{
					glVertex3f(drawn_objects[i][0]-(drawn_objects[i][8]*0.05),
							drawn_objects[i][1]+(drawn_objects[i][8]*0.05),0.0);
					glVertex3f(drawn_objects[i][0]+(drawn_objects[i][8]*0.05),
							drawn_objects[i][1]+(drawn_objects[i][8]*0.05),0.0);
	
					// Modify color for trippy effect
					glColor3f(drawn_objects[i][5]-0.6,
							drawn_objects[i][6]-0.6,
							drawn_objects[i][7]-0.6);
		
					glVertex3f(drawn_objects[i][0]+(drawn_objects[i][8]*0.05),
							drawn_objects[i][1]-(drawn_objects[i][8]*0.05),0.0);
					glVertex3f(drawn_objects[i][0]-(drawn_objects[i][8]*0.05),
							drawn_objects[i][1]-(drawn_objects[i][8]*0.05),0.0);
				}
			glEnd();
		}
		// Rectangle
		else if(drawn_objects[i][2] == 2)
		{
			glBegin(GL_POLYGON);
				// This is if we want it to be its own rotate origin
				if(drawn_objects[i][10] == 2)
				{
					glVertex3f(0-(drawn_objects[i][8]*0.05), 0+(drawn_objects[i][8]*0.2),0.0);
					glVertex3f(0+(drawn_objects[i][8]*0.05), 0+(drawn_objects[i][8]*0.2),0.0);
		
					// Modify color for trippy effect
					glColor3f(drawn_objects[i][5]-0.6,
							drawn_objects[i][6]-0.6,
							drawn_objects[i][7]-0.6);
		
					glVertex3f(0+(drawn_objects[i][8]*0.05), 0-(drawn_objects[i][8]*0.05),0.0);
					glVertex3f(0-(drawn_objects[i][8]*0.05), 0-(drawn_objects[i][8]*0.05),0.0);
				}
				else
				{
					glVertex3f(drawn_objects[i][0]-(drawn_objects[i][8]*0.05),
							drawn_objects[i][1]+(drawn_objects[i][8]*0.2),0.0);
					glVertex3f(drawn_objects[i][0]+(drawn_objects[i][8]*0.05),
							drawn_objects[i][1]+(drawn_objects[i][8]*0.2),0.0);
		
					// Modify color for trippy effect
					glColor3f(drawn_objects[i][5]-0.6,
							drawn_objects[i][6]-0.6,
							drawn_objects[i][7]-0.6);
		
					glVertex3f(drawn_objects[i][0]+(drawn_objects[i][8]*0.05),
							drawn_objects[i][1]-(drawn_objects[i][8]*0.05),0.0);
					glVertex3f(drawn_objects[i][0]-(drawn_objects[i][8]*0.05),
							drawn_objects[i][1]-(drawn_objects[i][8]*0.05),0.0);
				}
			glEnd();
		}
		// Triangle
		else if(drawn_objects[i][2] == 3)
		{
			glBegin(GL_TRIANGLES);
				// This is if we want it to be its own rotate origin
				if(drawn_objects[i][10] == 2)
				{
					glVertex3f(0-(drawn_objects[i][8]*0.05), 0+(drawn_objects[i][8]*0.05),0.0);
					glVertex3f(0+(drawn_objects[i][8]*0.05), 0+(drawn_objects[i][8]*0.05),0.0);
	
					// Modify color for trippy effect
					glColor3f(drawn_objects[i][5]-0.6,
							drawn_objects[i][6]-0.6,
							drawn_objects[i][7]-0.6);
	
					glVertex3f(0, 0-(drawn_objects[i][8]*0.05),0.0);
				}
				else
				{
					glVertex3f(drawn_objects[i][0]-(drawn_objects[i][8]*0.05), drawn_objects[i][1]+(drawn_objects[i][8]*0.05),0.0);
					glVertex3f(drawn_objects[i][0]+(drawn_objects[i][8]*0.05), drawn_objects[i][1]+(drawn_objects[i][8]*0.05),0.0);
	
					// Modify color for trippy effect
					glColor3f(drawn_objects[i][5]-0.6,
							drawn_objects[i][6]-0.6,
							drawn_objects[i][7]-0.6);
	
					glVertex3f(drawn_objects[i][0], drawn_objects[i][1]-(drawn_objects[i][8]*0.05),0.0);
				}
			glEnd();
		}
		glPopMatrix();
	}

	glutSwapBuffers();
}

// generic resize function, scales to W x H
void myReshape(GLsizei w, GLsizei h)
{
	win_width = w;
	win_height = h;

	printf("myReshape() called\n");

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(-1.0, 1.0, -1.0, 1.0, -1.0, 1.0);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	glViewport(0,0,win_width,win_height);
	glClearColor(0.0, 0.0, 0.0,0.0);
	glClear(GL_COLOR_BUFFER_BIT);
	display();
	glutSwapBuffers();
}

// generic initialization routine
void myinit(void)
{
	glViewport(0, 0, win_width, win_height);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(-1.0, 1.0, -1.0, 1.0, -1.0, 1.0);
	glClearColor(0.0, 0.0, 0.0, 0.0);
	glClear(GL_COLOR_BUFFER_BIT);
	glutSwapBuffers();
}

void root_menu(int id)
{
	// Dummy Function
}

// Menu to select shape
void shape_menu(int id)
{
	// square = 1
	// rectangle = 2
	// triangle = 3
	the_shape = id;
}

// Menu to select rotation speed/axix(es)
void rotate_menu(int id)
{
	// 0=x, 1=y, 2=z, 3=x/y
	if(id == 1) { the_rotate_axis = 0; the_rotate_speed = 2; }
	else if(id == 2) { the_rotate_axis = 1; the_rotate_speed = 2; }
	else if(id == 3) { the_rotate_axis = 2; the_rotate_speed = 2; }
	else if(id == 4) { the_rotate_axis = 3; the_rotate_speed = 2; }
	else if(id == 5) { the_rotate_axis = 0; the_rotate_speed = 8; }
	else if(id == 6) { the_rotate_axis = 1; the_rotate_speed = 8; }
	else if(id == 7) { the_rotate_axis = 2; the_rotate_speed = 8; }
	else if(id == 8) { the_rotate_axis = 3; the_rotate_speed = 8; }
	else if(id == 9) { the_rotate_speed = 0; }
}

// Menu to select color
void color_menu(int id)
{
	if(id == 1) { the_color_r = 1.0; the_color_g = 0.0; the_color_b = 0.0; }
	else if(id == 2) { the_color_r = 0.0; the_color_g = 1.0; the_color_b = 0.0; }
	else if(id == 3) { the_color_r = 0.0; the_color_g = 0.0; the_color_b = 1.0; }
	else if(id == 4) { the_color_r = 0.0; the_color_g = 1.0; the_color_b = 1.0; }
	else if(id == 5) { the_color_r = 1.0; the_color_g = 0.0; the_color_b = 1.0; }
	else if(id == 6) { the_color_r = 1.0; the_color_g = 1.0; the_color_b = 0.0; }
	else if(id == 7) { the_color_r = 1.0; the_color_g = 1.0; the_color_b = 1.0; }
	else if(id == 8) { the_color_r = 0.0; the_color_g = 0.0; the_color_b = 0.0; }
	else if(id == 9) { the_color_r = 0.25; the_color_g = 0.0; the_color_b = 0.8; }
	else if(id == 10) { the_color_r = 0.5; the_color_g = 0.5; the_color_b = 0.5; }
}

void size_menu(int id)
{
	the_size = id;
}

// Quits/Clears
void system_menu(int id)
{
	if(id == 1)
		num_objects = 0;
	else if(id == 3)
		exit(0);
}

void origin_menu(int id)
{
	the_origin = id;
}

// Handles clicks from the mouse
void mouse(int btn, int state, int x, int y)
{
	float thex, they;

	// Fix stupid position
	y = win_height - y;

	if(btn == GLUT_LEFT_BUTTON && state == GLUT_UP)
	{
		// Fix the -1.0, 1.0 ortho discrepency with pixel coords
		if(x < ((float)win_width)/2)
		{
			thex = ((float)x) / (((float)win_width)/2);
			thex -= 1;
		}
		else
			thex = (((float)x)-((float)win_width/2)) / ((float)win_width / 2.00);
	
		if(y < ((float)win_height)/2)
		{
			they = ((float)y) / (((float)win_height)/2);
			they -= 1;
		}
		else
			they = (((float)y)-((float)win_height/2)) / ((float)win_height / 2.00);
	
//		printf("(%f, %f)\n", thex, they);
	
		// If we don't hit the limit of objects, assign the properties to the new object
		if(num_objects < MAXOBJECTS)
		{
			drawn_objects[num_objects][0] = thex;
			drawn_objects[num_objects][1] = they;
			drawn_objects[num_objects][2] = the_shape;
			drawn_objects[num_objects][3] = the_rotate_axis;
			drawn_objects[num_objects][4] = the_rotate_speed;
			drawn_objects[num_objects][5] = the_color_r;
			drawn_objects[num_objects][6] = the_color_g;
			drawn_objects[num_objects][7] = the_color_b;
			drawn_objects[num_objects][8] = the_size;
			drawn_objects[num_objects][9] = 0;
			drawn_objects[num_objects][10] = the_origin;
			num_objects++;
		}
		else
			printf("Error: You maxed out, can't have more than %d objects\n",
					MAXOBJECTS);
	}
}

// Function to call when the mouse is dragged
void mouse_motion(int x, int y)
{
	float thex, they;

	// Fix the mouse origin discrepency
	y = win_height - y;

	// Fix the -1.0, 1.0 ortho discrepency with pixel coords
	if(x < ((float)win_width)/2)
	{
		thex = ((float)x) / (((float)win_width)/2);
		thex -= 1;
	}
	else
		thex = (((float)x)-((float)win_width/2)) / ((float)win_width / 2.00);

	if(y < ((float)win_height)/2)
	{
		they = ((float)y) / (((float)win_height)/2);
		they -= 1;
	}
	else
		they = (((float)y)-((float)win_height/2)) / ((float)win_height / 2.00);

//	printf("(%f, %f)\n", thex, they);

	// Create the new object
	if(num_objects < MAXOBJECTS)
	{
		drawn_objects[num_objects][0] = thex;
		drawn_objects[num_objects][1] = they;
		drawn_objects[num_objects][2] = the_shape;
		drawn_objects[num_objects][3] = the_rotate_axis;
		drawn_objects[num_objects][4] = the_rotate_speed;
		drawn_objects[num_objects][5] = the_color_r;
		drawn_objects[num_objects][6] = the_color_g;
		drawn_objects[num_objects][7] = the_color_b;
		drawn_objects[num_objects][8] = the_size;
		drawn_objects[num_objects][9] = 0;
		drawn_objects[num_objects][10] = the_origin;
		num_objects++;
	}
	else
		printf("Error: You maxed out, can't have more than %d objects\n",
				MAXOBJECTS);
}

// If we type a key on the keyboad
void key(unsigned char k, int x, int y)
{
	// deletes one object
	if((k == 'd') && (num_objects > 0))
		num_objects--;
	// clears all objects
	else if((k == 'd') && (num_objects == 0))
		printf("Can't delete any more objects...\n");
	else if(k == 'c')
		num_objects = 0;
	// toggles spin on/off
	else if(k == 's')
	{
		if(global_spin)
			global_spin = 0;
		else
			global_spin = 1;
	}
}

// Main function
int main(int argc, char **argv)
{
	int originmenu, shapemenu, rotatemenu, colormenu, sizemenu, systemmenu, i, j;

	// allocate memory
	drawn_objects = (float **)malloc(sizeof(float)*MAXOBJECTS);
	for(i=0; i<MAXOBJECTS; i++)
		drawn_objects[i] = (float *)malloc(sizeof(float)*11);
	
	// set the global width and height initially to the default window size
	win_width = INIT_W;
	win_height = INIT_H;
		
	// clear the array (is this really necessary?)
	for(i=0; i < MAXOBJECTS; i++)
		for(j=0; j < 11; j++)
			drawn_objects[i][j] = 0;

	// glut stuff and create the menus
	
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
	glutInitWindowSize(INIT_W, INIT_H);
	glutCreateWindow("Prolixium Shapes");

	glutDisplayFunc(display);
	glutIdleFunc(display);

	originmenu = glutCreateMenu(origin_menu);
	glutAddMenuEntry("Use Center", 1);
	glutAddMenuEntry("Use Object", 2);

	shapemenu = glutCreateMenu(shape_menu);
	glutAddMenuEntry("Square", 1);
	glutAddMenuEntry("Rectangle", 2);
	glutAddMenuEntry("Triangle", 3);

	rotatemenu = glutCreateMenu(rotate_menu);
	glutAddMenuEntry("Slow X-Axis", 1);
	glutAddMenuEntry("Slow Y-Axis", 2);
	glutAddMenuEntry("Slow Z-Axis", 3);
	glutAddMenuEntry("Slow X/Y-Axis", 4);
	glutAddMenuEntry("Fast X-Axis", 5);
	glutAddMenuEntry("Fast Y-Axis", 6);
	glutAddMenuEntry("Fast Z-Axis", 7);
	glutAddMenuEntry("Fast X/Y-Axis", 8);
	glutAddMenuEntry("No Rotation", 9);

	colormenu = glutCreateMenu(color_menu);
	glutAddMenuEntry("Red", 1);
	glutAddMenuEntry("Green", 2);
	glutAddMenuEntry("Blue", 3);
	glutAddMenuEntry("Cyan", 4);
	glutAddMenuEntry("Magenta", 5);
	glutAddMenuEntry("Yellow", 6);
	glutAddMenuEntry("White", 7);
	glutAddMenuEntry("Black", 8);
	glutAddMenuEntry("Light Blue", 9);
	glutAddMenuEntry("Grey", 10);

	sizemenu = glutCreateMenu(size_menu);
	glutAddMenuEntry("Original Size", 1);
	glutAddMenuEntry("Tiny", 2);
	glutAddMenuEntry("Small", 3);
	glutAddMenuEntry("Medium", 4);
	glutAddMenuEntry("Larger", 5);
	glutAddMenuEntry("Large", 6);
	glutAddMenuEntry("Very Large", 7);
	glutAddMenuEntry("Huge", 8);
	glutAddMenuEntry("Just For Fun (Too Big)", 9);

	systemmenu = glutCreateMenu(system_menu);
	glutAddMenuEntry("Clear", 1);
	glutAddMenuEntry("Quit", 3);

	glutCreateMenu(root_menu);
	glutCreateMenu(root_menu);
	glutAddSubMenu("Shapes", shapemenu);
	glutAddSubMenu("Rotation", rotatemenu);
	glutAddSubMenu("Color", colormenu);
	glutAddSubMenu("Size", sizemenu);
	glutAddSubMenu("Origin", originmenu);
	glutAddSubMenu("System", systemmenu);

	// right click for the menu
	glutAttachMenu(GLUT_RIGHT_BUTTON);

	myinit();

	glutReshapeFunc(myReshape);
	glutKeyboardFunc(key);
	glutMouseFunc(mouse);
	glutMotionFunc(mouse_motion);

	glutMainLoop();

	return 0;
}
